#!/usr/bin/perl
# <plaintext>  just in case you look at this via a browser

#########################################################################
####                                                                #####
####                       CRON SCRIPT                              #####
####                                                                #####
####                                                                #####
####    domisse@w3perl.com                   version 19/11/2007     #####
####                                                                #####
#########################################################################

# option available in crontab 
# 01 * * * * /home/domisse/public_html/w3perl/cron-w3perl.pl -c /home/domisse/public_html/w3perl/config-hplyot.pl
 
# customise your own value in the 'user launching configuration' part.

$version = "3.01";
$verdate = "19/11/07";

require "/var/www/cgi-bin/w3perl/libw3perl.pl";

$w3perlpath = "/var/www/cgi-bin/w3perl"; # Do not remove this line

$w3perlpath .= $dirsep;

# Fix problem with Windows shortcut
$w3perlpath = &Windows_ShortPath($w3perlpath);
if ($opt_c ne '') {
    $configfile = &Windows_ShortPath($opt_c);
    $option = "-c ".$configfile; 
}

#use Cwd;
#use POSIX qw( :sys_wait_h );

# init
$nb_proc = 1;
$process_to_launch = 0;

$startrun = "$hour:$minute:$second";
$daystart = $day;
$minutestart = $minute;
$hourstart = $hour;

#$today = $day."/".$month."/".$year." ".$hour."h".$minute;

#print "$yesterday - $day,$countmonth,$year\n";
$yesterday = &yesterday_date($day,$countmonth,$year);

$wday = (localtime)[6];

#print "$yesterday - $day,$countmonth,$year\n";

### choose which scripts you want to run (0 = off ; 1 = on)
# compatibilite avec les anciens fichiers de config

if ($actif_hour eq '') {
    $actif_real = 1;
    $actif_hour = 1;
    $actif_day = 1;
    $actif_week = 1;
    $actif_month = 1;
    $actif_year = 0;
    $actif_agent = 1;
    $actif_refer = 1;
    $actif_session = 1;
    $actif_error = 1;
    $actif_history = 1;
    $actif_url = 1;
}

if ($ftp_format == 1 || $squid_format == 1 || $mail_format == 1) {
    $actif_real = 1;
    $actif_hour = 1;
    $actif_day = 1;
    $actif_week = 1;
    $actif_month = 1;
    $actif_year = 1;
    $actif_agent = 0;
    $actif_refer = 0;
    $actif_session = 1;
    $actif_error = 0;
    $actif_history = 0;
    $actif_url = 0;
}

if ($squid_format == 1) {
    $actif_url = 0;
}

if ($mail_format == 1) {
    $actif_session = 0;
}

#################################################################
###                      Test Windows                         ###
#################################################################

$car = substr($w3perlpath,1,1);
$nt = 1 if ($car eq ':');

#################################################################
###                      get local time                       ###
#################################################################

($a,$min,$hour,$d,$month,$year,$weekofday,$yearday) = localtime(time);

$month++;
$weekofyear = int($yearday/7)+1;

#################################################################
###              Scripts options to customize                 ###
#################################################################

#$option_real = "";
#$option_hour = "";
#$option_day = "";
#$option_week = "-g line";
#$option_month = "";
#$option_pages = "";
#$option_inc = "";
#$option_refer = "";
#$option_agent = "";
#$option_error = "-k";
#$option_session = "-d 10"; # default session is computed for the last 10 days
#$option_history = "";

#################################################################
###            user launching configuration                   ###
#################################################################

### run cron-xxx.pl -h to see specific script options 
# compatibilite avec les anciens fichiers de config

if ($hour_launch eq '') {

### hour

$hour_launch = 1; # every hour

### day

$day_launch = 1; # every day
$day_launch_time = 0; # launch at midnight

### week

$week_launch = 1; # every day
$week_launch_time = 1; # launch at 1 am o'clock
$week_launch_day = 1; # launch on monday (0 = sunday, 6 = saturday)

### month

$month_launch = 1; # every day
$month_launch_time = 1; # launch at 1 am o'clock
$month_launch_day = 1; # launch on the first day of each month

### year

$year_launch = 1; # every day
$year_launch_time = 1; # launch at 1 am o'clock

### inc

$inc_launch = 1; # everyday
$inc_launch_time = 0; # launch at midnight

## refer

$refer_launch = 1; # everyday
$refer_launch_time = 0; # launch at 0 o'clock

## agent

$agent_launch = 1; # everyday
$agent_launch_time = 0; # launch at 0 am o'clock

## error

$error_launch = 1; # everyday
$error_launch_time = 1; # launch at 1 am o'clock

## session

$session_launch = 1; # every 5 days
$session_launch_time = 0; # launch at 0 o'clock

## url

#$option_url = "";
#$url_launch = 5; # every 5 days
#$url_launch_time = 1; # launch at 1 o'clock

## history

$history_launch = 1; # everyday
$history_launch_time = 2; # launch at 2 am o'clock
}

#################################################################
###            checking everything could be launch            ###
#################################################################

if ($hour_launch != 1) {
&warning("cron-day",$day_launch_time);
&warning("cron-week",$week_launch_time);
&warning("cron-month",$month_launch_time);
&warning("cron-year",$year_launch_time);
&warning("cron-inc",$inc_launch_time);
&warning("cron-refer",$refer_launch_time);
&warning("cron-agent",$agent_launch_time);
&warning("cron-error",$error_launch_time);
&warning("cron-session",$session_launch_time);
#&warning("cron-url",$url_launch_time);
&warning("cron-history",$history_launch_time);
}

#################################################################
###            parsing the command line option                ###
#################################################################

if ($opt_h == 1) {
      print STDOUT "Usage : \n";
      print STDOUT "        -c <file> : load configuration file\n";
      print STDOUT "        -a        : reset all your stats\n";
      print STDOUT "        -d <nbdays> : number of days to scan\n";      
      print STDOUT "        -e        : incremental run for all scripts\n";
#      print STDOUT "        -u        : reset all your stats (manual use)\n";
      print STDOUT "        -x        : show default value for flag options\n";
      print STDOUT "        -b        : show crontab\n";
      print STDOUT "        -v        : version\n";
      print STDOUT "\n";
      exit;
}

if ($opt_x == 1) {
      print STDOUT "Default : \n";
      print STDOUT "          -c : $configfile\n";
      print STDOUT "          -a : ";
      &id($opt_a);
      print STDOUT "          -d <nbdays>   : $nbdays\n";      
      print STDOUT "          -e : ";
      &id($opt_e);      
#      print STDOUT "          -u : ";
#      &id($opt_u);
      print STDOUT "          -v : $version\n";
      exit;
}

if ($opt_v == 1) {
      print STDOUT "cron-w3perl.pl version $version $verdate\n";
      exit;
}

if ($opt_d ne '') {
$option .= " -d $opt_d";
$opt_a = 1;
}


if ($opt_a == 1 && $opt_e == 1) {
    &error_exit("> Cannot run initialisation and update together ! Choose one mode : a for init, e for update");
    exit;
}

if ($opt_b == 1) {
    print STDOUT "Crontab :\n";

    # hour
    
    print STDOUT "0 ";

    if ($actif_hour == 1) {
	if ($hour_launch == 1) {
	    print STDOUT "*";
	} else {
	    $cday = "(";
	    for ($k=2;$k<=24;$k++) {
		$cday .= "$k," if (($k/$hour_launch) == int($k/$hour_launch));
	    }
	    chop($cday);
	    $cday .= ")";
	    print STDOUT "$cday";
	}
	print STDOUT " * * * cron-hour$plext $option_hour $option\n";
    }

    # day

    if ($actif_day == 1) {
	print STDOUT "0 $day_launch_time ";
	if ($day_launch == 1) {
	    print STDOUT "*";
	} else {
	    $cday = "(";
	    for ($k=2;$k<=31;$k++) {
		$cday .= "$k," if (($k/$day_launch) == int($k/$day_launch));
	    }
	    chop($cday);
	    $cday .= ")";
	    print STDOUT "$cday";
	}
	print STDOUT " * * cron-day$plext $option_day $option\n";
    }

    # week
    
    if ($actif_week == 1) {
	print STDOUT "0 $week_launch_time ";
	if ($week_launch == 1) {
	    print STDOUT "*";
	} else {
	    $begin = $day+($week_launch_day-$wday);
	    $begin = $begin - (7*int($begin/7));
	    $cday = "(";
	    for ($k=$begin;$k<=31;$k+=7*$week_launch) {
		$cday .= "$k,";
	    }
	    chop($cday);
	    $cday .= ")";
	    print STDOUT "$cday";
	}
	print STDOUT " * $week_launch_day cron-week$plext $option_week $option\n";
    }

    # month

    if ($actif_month == 1) {    
	print STDOUT "0 $month_launch_time $month_launch_day * * cron-month$plext $option_month $option\n";
    }

    # year

    if ($actif_year == 1) {    
	print STDOUT "0 $year_launch_time $year_launch * * cron-year$plext $option_year $option\n";
    }

    # inc
    
    print STDOUT "0 $inc_launch_time ";
    if ($inc_launch == 1) {
    print STDOUT "*";
    } else {
    $cday = "(";
    for ($k=2;$k<=31;$k++) {
    $cday .= "$k," if (($k/$inc_launch) == int($k/$inc_launch));
    }
    chop($cday);
    $cday .= ")";
    print STDOUT "$cday";
    }
    print STDOUT " * * cron-inc$plext $option_inc $option\n";

    # refer

    if ($actif_refer == 1) {
	print STDOUT "0 $refer_launch_time ";
	if ($refer_launch == 1) {
	    print STDOUT "*";
	} else {
	    $cday = "(";
	    for ($k=2;$k<=31;$k++) {
		$cday .= "$k," if (($k/$refer_launch) == int($k/$refer_launch));
	    }
	    chop($cday);
	    $cday .= ")";
	    print STDOUT "$cday";
	}
	print STDOUT " * * cron-refer$plext $option_refer $option\n";
    }
 
    # agent

    if ($actif_agent == 1) {
	print STDOUT "0 $agent_launch_time ";
	if ($agent_launch == 1) {
	    print STDOUT "*";
	} else {
	    $cday = "(";
	    for ($k=2;$k<=31;$k++) {
		$cday .= "$k," if (($k/$agent_launch) == int($k/$agent_launch));
	    }
	    chop($cday);
	    $cday .= ")";
	    print STDOUT "$cday";
	}
	print STDOUT " * * cron-agent$plext $option_agent $option\n";
    }

    # error

    if ($actif_error == 1) {
	print STDOUT "0 $error_launch_time ";
	if ($error_launch == 1) {
	    print STDOUT "*";
	} else {
	    $cday = "(";
	    for ($k=2;$k<=31;$k++) {
		$cday .= "$k," if (($k/$error_launch) == int($k/$error_launch));
	    }
	    chop($cday);
	    $cday .= ")";
	    print STDOUT "$cday";
	}
	print STDOUT " * * cron-error$plext $option_error $option\n";
    }

    # session

    if ($actif_session == 1) {
	print STDOUT "0 $session_launch_time ";
	if ($session_launch == 1) {
	    print STDOUT "*";
	} else {
	    $cday = "(";
	    for ($k=2;$k<=31;$k++) {
		$cday .= "$k," if (($k/$session_launch) == int($k/$session_launch));
	    }
	    chop($cday);
	    $cday .= ")";
	    print STDOUT "$cday";
	}
	print STDOUT " * * cron-session$plext $option_session $option\n";
    }

    # url

    if ($actif_url == 1) {
	print STDOUT "0 $url_launch_time ";
	if ($url_launch == 1) {
	    print STDOUT "*";
	} else {
	    $cday = "(";
	    for ($k=2;$k<=31;$k++) {
		$cday .= "$k," if (($k/$url_launch) == int($k/$url_launch));
	    }
	    chop($cday);
	    $cday .= ")";
	    print STDOUT "$cday";
	}
	print STDOUT " * * cron-url$plext $option_url $option\n";
    }
            
    exit;
}



#if ($ENV{'REQUEST_METHOD'} ne "GET") {
#print STDOUT "\nAdd the following line in your crontab :\n";
#print STDOUT "0 ";

#if ($hour_launch == 1) {
#print STDOUT "*";
#} else {
#   $cday = "(";
#   for ($k=2;$k<=24;$k++) {
#      $cday .= "$k," if (($k/$hour_launch) == int($k/$hour_launch));
#   }
#   chop($cday);
#   $cday .= ")";
#   print STDOUT "$cday";
#   }

#print STDOUT " * * * ".$w3perlpath."cron-w3perl$plext $option\n";
#print STDOUT "where 0 is the minute of the hour, change it to whatever you want. (0-59)";
#print STDOUT "\n(if you are using w3perl for several web, better to use different minute launch time to avoid CPU increase)\n\n";
#}

&MakeDirectories;

#################################################################
###       reset for first use (don't use in crontab !)        ###
#################################################################

#if ($opt_u != 0) {
#print "<I><B>" if ($ENV{'REQUEST_METHOD'} eq "GET");
#print "Resetting all stats data....\n";
#print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

#if ($opt_a != 0 || $opt_u != 0) {
if ($opt_a != 0) {

    if ($actif_url == 1) {
	$string = $w3perlpath."cron-url".$plext;
	$string .= " ".$option_url if ($option_url ne '');
	push(@list,$string);
    }

    $string = $w3perlpath."cron-pages".$plext;
    $string .= " ".$option_pages if ($option_pages ne '');
    push(@list,$string);

#    if ($actif_session == 1) {
#	if ($exclude_robot == 1) {
#	    $option_session = "-m"; 
#	    $string = $w3perlpath."cron-session".$plext." ".$option_session;
#	    push(@list,$string) ;
#	}
#    }

    if ($actif_agent == 1) {
	$option_agent .= " -b";
	$string = $w3perlpath."cron-agent".$plext;
	$string .= " ".$option_agent if ($option_agent ne '');
	push(@list,$string);
    }

    if ($actif_refer == 1) {
	$option_refer .= " -b";
	$string = $w3perlpath."cron-refer".$plext;
	$string .= " ".$option_refer if ($option_refer ne '');
	push(@list,$string);
    }


    if ($actif_hour == 1) {
	$option_day_hour = "-b";
	$string = $w3perlpath."cron-hour".$plext;
	$string .= " ".$option_hour if ($option_hour ne '');
	$string .= " ".$option_day_hour;
	push(@list,$string);
	$process_to_launch++;
    }

    if ($actif_hour == 1) {
	$option_hour .= "";
	$string = $w3perlpath."cron-hour".$plext;
	$string .= " ".$option_hour if ($option_hour ne '');
	push(@list,$string);
    }


    if ($actif_real == 1) {
	$option_real .= " -n";
	$string = $w3perlpath."cron-hour".$plext;
	$string .= " ".$option_real if ($option_real ne '');
	push(@list,$string);
    }

    if ($actif_week == 1) {
	$string = $w3perlpath."cron-week".$plext;      
	$string .= " ".$option_week if ($option_week ne '');
	push(@list,$string);
    }


    if ($actif_month == 1) {
	$string = $w3perlpath."cron-month".$plext;
	$string .= " ".$option_month if ($option_month ne '');
	push(@list,$string);
    }


    if ($actif_year == 1) {
	$string = $w3perlpath."cron-year".$plext;
	$string .= " ".$option_year if ($option_year ne '');
	push(@list,$string);
    }

    if ($actif_session == 1) {
	$option_session .= ""; 
#	$option_session = " -u" if ($exclude_robot == 1);
	$string = $w3perlpath."cron-session".$plext;
	$string .= " ".$option_session if ($option_session ne '');
	push(@list,$string);
    }

    if ($actif_day == 1) {
	$string = $w3perlpath."cron-day".$plext;
	$string .= " ".$option_day if ($option_day ne '');
	push(@list,$string);
    }

    if ($actif_error == 1) {
	$option_error .= " -b";
	$string = $w3perlpath."cron-error".$plext;
	$string .= " ".$option_error if ($option_error ne '');
	push(@list,$string);
    }

    if ($actif_history == 1) {
#	$option_history .= " -b";
	$string = $w3perlpath."cron-history".$plext;
	$string .= " ".$option_history if ($option_history ne '');
	push(@list,$string);
    }

    print "<B>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    print "<P>\n<DIV CLASS=\"launch_main\">\n " if ($ENV{'REQUEST_METHOD'} eq "GET");
    print " *** Initializing stats ($today) *** \n";
    print "</DIV></B><BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");


# Retrieve external log
    &retrieve_external_logfile($fileroot,$remote_host_log) if ($retrieve_external_log == 1);

    $contentype = "-y -w";

  BOUCLE:
    for ($i=0;$i<=$#list;$i++) {

	print "<P>\n<DIV CLASS=\"launch_title\">\n " if ($ENV{'REQUEST_METHOD'} eq "GET");
	$timesec = time;
#	&get_time($timesec);
	($date,$datehour,$datemisc) = &get_time($timesec);
	$today = $date." ".$datehour;
	print "> Launching $list[$i] $option ($today)\n";
	print "</DIV>\n<BR>\n" if ($ENV{'REQUEST_METHOD'} eq "GET");

	$cmd = "$list[$i] $contentype $option";
	$commit = system($cmd);
	    if ($commit != 0) {
		print "<TABLE>\n<TR>\n<TD WIDTH=110></TD><TD>\n" if ($ENV{'REQUEST_METHOD'} eq "GET");
		&error_exit("> Fatal error, stats aborted");
		print "</TD>\n</TR>\n</TABLE>\n</BODY>\n</HTML>\n" if ($ENV{'REQUEST_METHOD'} eq "GET");
		$fatal = 1;
		last BOUCLE;
	    }
	}

    $datesyst = &ctime(time);
    ($dayletter,$month,$day,$hourdate,$a,$year) = split(/[ \t\n\[]+/,$datesyst);
    ($hour,$minute,$second) = split(/:/,$hourdate);

    $dayend = $day;

    $endrun = "$hour:$minute:$second";

    if ($daystart != $dayend) {

	$tmpstart = 1440-(($hourstart*60)+$minutestart);
	$tmpend = ($hour*60)+$minute;
	$hour = ($dayend-$daystart-1)*24;

	$tmpmin = $tmpstart+$tmpend;
	$hour = int($tmpmin/60);
    
	$min = $tmpmin-($hour*60);
    } else {
	($hour,$min,$sec) = &timetaken($startrun,$endrun);
    }

    if ($fatal == 0) {
	print "<B>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	print "Stats computed in";

	print " $hour h" if ($hour > 0);
	print " $min min";
	print " $sec sec" if ($daystart == $dayend);
	print "</B>\n<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	print "\n\n";

	&admin_goback if ($ENV{'REQUEST_METHOD'} eq "GET");
#	print "<P><I>You can now check the output stats, please <A HREF=\"javascript:history.back()\">go back</A> to the admin homepage</I>\n" if ($ENV{'REQUEST_METHOD'} eq "GET");
    } else {

    }
    exit(0);
}

sub run_and_check_exit_daemon {
#  local $SIG{'CHLD'}; # desactivate CHLD catching to access $?: problems with SIGQUIT
#  my ($curr_filename,@tmp) = @_;
  my ($command) = @_;
#  my $command = join(' ',@tmp);
#  print "$curr_filename - $command\n";
#  print "Running $command\n";
  system($command);
#  print "Code : $? - WIFEXITED($?) - WEXITSTATUS($?) - WIFSIGNALED($?)\n<P>";
  if (WIFEXITED($?)) { # child process exited normally
#      print "AA\n<P>";
      # exit status of the child not = 0
    if (WEXITSTATUS($?) != 0) {
#      print "AA1\n<P>";
#        my $new_filename = $curr_filename;
#        $new_filename =~ s/$curr_ext$/$err_ext/;
#        print "rename $curr_filename, $new_filename\n" if $verbose;
#        rename $curr_filename, $new_filename;
#       print "ERROR: the following command returned the non zero value ".WEXITSTATUS($?).":\n$command\n";
       die ("ERROR: the following command returned the non zero value ".WEXITSTATUS($?).":\n$command\n");
    }
  } else {
#      print "BB\n<P>";
    #  child process terminated because of a signal
    if (WIFSIGNALED($?)) {
#      print "BB1\n<P>";
#        my $new_filename = $curr_filename;
#        $new_filename =~ s/$curr_ext$/$err_ext/;
#        print "rename $curr_filename, $new_filename\n" if $verbose;
#        rename $curr_filename, $new_filename;
        die ("ERROR: the following command exited because of signal ".WTERMSIG($?).":\n$command\n");
    }
#    my $new_filename = $curr_filename;
#   $new_filename =~ s/$curr_ext$/$err_ext/;
#    print "rename $curr_filename, $new_filename\n" if $verbose;
#    rename $curr_filename, $new_filename;
#      print "BB2\n<P>";
#    print "ERROR: the following command failed to exit normally:\n$command\n";
    die ("ERROR: the following command failed to exit normally:\n$command\n");
  }
}

#################################################################
###                    force incremental fork                 ###
#################################################################

if ($opt_e != 0) {

#$string = $w3perlpath."cron-url".$plext." ".$option_url;
#push(@list,$string);
#$process_to_launch++;

    if ($actif_url == 1) {
	&daily("cron-url",$option_url,$url_launch,$url_launch_time);
#	$string = $w3perlpath."cron-url".$plext;
#	$string .= " ".$option_url if ($option_url ne '');
#	push(@list,$string);
#	$process_to_launch++;
    }

    if ($actif_refer == 1) {
	$string = $w3perlpath."cron-refer".$plext;
	$string .= " ".$option_refer if ($option_refer ne '');
	push(@list,$string);
	$process_to_launch++;
    }

    if ($actif_agent == 1) {
	$string = $w3perlpath."cron-agent".$plext;
	$string .= " ".$option_agent if ($option_agent ne '');
	push(@list,$string);
	$process_to_launch++;
    }

#    if ($actif_session == 1) {
#	if ($exclude_robot == 1) {
#	    $option_session = "-m";
#	    $string = $w3perlpath."cron-session".$plext." ".$option_session;
#	    push(@list,$string);
#	    $option_session = "";
#	    $process_to_launch++;
#	}
#    }

    $string = $w3perlpath."cron-inc".$plext;
    $string .= " ".$option_inc if ($option_inc ne '');
    push(@list,$string);
    $process_to_launch++;

    if ($actif_hour == 1) {
	$option_day_hour = "-j $yesterday";
	$string = $w3perlpath."cron-hour".$plext;
	$string .= " ".$option_hour if ($option_hour ne '');
	$string .= " ".$option_day_hour;
	push(@list,$string);
	$process_to_launch++;
    }

    if ($actif_hour == 1) {
	$string = $w3perlpath."cron-hour".$plext;
	$string .= " ".$option_hour if ($option_hour ne '');
	push(@list,$string);
	$process_to_launch++;
    }

    if ($actif_real == 1) {
	$option_real .= " -n";
	$string = $w3perlpath."cron-hour".$plext;
	$string .= " ".$option_real if ($option_real ne '');
	push(@list,$string);
	$process_to_launch++;
    }

    if ($actif_week == 1) {
	$string = $w3perlpath."cron-week".$plext;
	$string .= " ".$option_week if ($option_week ne '');
	push(@list,$string);
	$process_to_launch++;
    }

    if ($actif_month == 1) {
	$string = $w3perlpath."cron-month".$plext;
	$string .= " ".$option_month if ($option_month ne '');
	if ((($month/$month_launch) == int($month/$month_launch)) && ($day == $month_launch_day)) {
	    push(@list,$string);
	    $process_to_launch++;
	}
    }

    if ($actif_year == 1) {
	$string = $w3perlpath."cron-year".$plext;
	$string .= " ".$option_year if ($option_year ne '');
	push(@list,$string);
	$process_to_launch++;
    }

    if ($actif_session == 1) {
#	$option_session = " -u";
	$string = $w3perlpath."cron-session".$plext;
	$string .= " ".$option_session if ($option_session ne '');
	push(@list,$string);
	$process_to_launch++;
	$option_session = "";
    }

    if ($actif_day == 1) {
	$string = $w3perlpath."cron-day".$plext;
	$string .= " ".$option_day if ($option_day ne '');
	push(@list,$string);
	$process_to_launch++;
    }

    if ($actif_error == 1) {
	$string = $w3perlpath."cron-error".$plext;
	$string .= " ".$option_error if ($option_error ne '');
	push(@list,$string);
	$process_to_launch++;
    }

    if ($actif_history == 1) {
	$string = $w3perlpath."cron-history".$plext;
	$string .= " ".$option_history if ($option_history ne '');
	push(@list,$string);
	$process_to_launch++;
    }

}

#################################################################
###         adding the script in the fork list                ###
#################################################################

if ($opt_e != 1) {

    &daily("cron-url",$option_url,$url_launch,$url_launch_time) if ($actif_url == 1);
    &daily("cron-refer",$option_refer,$refer_launch,$refer_launch_time) if ($actif_refer == 1);
    &daily("cron-agent",$option_agent,$agent_launch,$agent_launch_time) if ($actif_agent == 1);
    &daily("cron-session",$option_session,$session_launch,$session_launch_time) if ($actif_session == 1);

### inc

    $string = "cron-inc";
    &daily($string,$option_inc,$inc_launch,$inc_launch_time);

### real stats

    if ($actif_real == 1) {
	$option_real .= " -n";
	$string = $w3perlpath."cron-hour".$plext." ".$option_real;        

	if (($hour/$hour_launch) == int($hour/$hour_launch)) {
	    push(@list,$string) ;
	    $process_to_launch++;
	}
    }

### hour 

    if ($actif_hour == 1) {
	$string = $w3perlpath."cron-hour".$plext;
	$string .= " ".$option_hour if ($option_hour ne '');
	if (($hour/$hour_launch) == int($hour/$hour_launch)) {
	    push(@list,$string) ;
	    $process_to_launch++;
	}
    }

### week

    if ($actif_week == 1) {
	$string = $w3perlpath."cron-week".$plext;
	$string .= " ".$option_week if ($option_week ne '');
	if ((($weekofyear/$week_launch) == int($weekofyear/$week_launch)) && ($weekofday == $week_launch_day) && ($hour == $week_launch_time)) {
	    push(@list,$string);
	    $process_to_launch++;
	}
    }

### month

    if ($actif_month == 1) {
	$string = $w3perlpath."cron-month".$plext;
	$string .= " ".$option_month if ($option_month ne '');
	if ((($month/$month_launch) == int($month/$month_launch)) && ($day == $month_launch_day) && ($hour == $month_launch_time)) {
	    push(@list,$string);
	    $process_to_launch++;
	}
    }

### year

    if ($actif_year == 1) {
	$string = $w3perlpath."cron-year".$plext;
	$string .= " ".$option_year if ($option_year ne '');
	if ((($weekofyear/$year_launch) == int($weekofyear/$year_launch)) && ($hour == $year_launch_time)) {
	    push(@list,$string);
	    $process_to_launch++;
	}
    }

### make a comment in front of the line you don't want to run

&daily("cron-error",$option_error,$error_launch,$error_launch_time) if ($actif_error == 1);
&daily("cron-history",$option_history,$history_launch,$history_launch_time) if ($actif_history == 1);

### day 

    if ($actif_day == 1) {
	$string = "cron-day";
	&daily($string,$option_day,$day_launch,$day_launch_time);
    }
}


#################################################################
###              main loop to fork processes                  ###
#################################################################

#$timesec = time;
#&get_time($timesec);
#$today = $date." ".$datehour;
print "<B>" if ($ENV{'REQUEST_METHOD'} eq "GET");
print "<P>\n<DIV CLASS=\"launch_main\">\n " if ($ENV{'REQUEST_METHOD'} eq "GET");
print " *** Upgrading stats ($today) *** \n";
print "</DIV></B><BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");


# Retrieve external log
&retrieve_external_logfile($fileroot,$remote_host_log) if ($retrieve_external_log == 1);

$contentype = "-y -w";

for ($i=0;$i<$process_to_launch;$i+=$nb_proc) {
    for ($k=0;$k<$nb_proc;$k++) {
	    
	$l= $i+$k;

	print "<P>\n<DIV CLASS=\"launch_title\">\n " if ($ENV{'REQUEST_METHOD'} eq "GET");
	$timesec = time;
#	&get_time($timesec);
	($date,$datehour,$datemisc) = &get_time($timesec);
	$today = $date." ".$datehour;
	print "> Launching $list[$l] $option ($today)\n";
	print "</DIV>\n<BR>\n" if ($ENV{'REQUEST_METHOD'} eq "GET");

	$cmd = "$list[$l] $contentype $option";
	$commit = system($cmd);
	if ($commit != 0) {
	    print "<TABLE>\n<TR>\n<TD WIDTH=110></TD><TD>\n" if ($ENV{'REQUEST_METHOD'} eq "GET");
	    &error_exit("> Fatal error, stats aborted");
	    print "</TD>\n</TR>\n</TABLE>\n</BODY>\n</HTML>\n" if ($ENV{'REQUEST_METHOD'} eq "GET");
	    $fatal = 1;
	    last BOUCLE;
	}
    }
}

$datesyst = &ctime(time);
($dayletter,$month,$day,$hourdate,$a,$year) = split(/[ \t\n\[]+/,$datesyst);
($hour,$minute,$second) = split(/:/,$hourdate);

$dayend = $day;

$endrun = "$hour:$minute:$second";

if ($daystart != $dayend) {
    
    $tmpstart = 1440-(($hourstart*60)+$minutestart);
    $tmpend = ($hour*60)+$minute;
    $hour = ($dayend-$daystart-1)*24;

    $tmpmin = $tmpstart+$tmpend;
    $hour = int($tmpmin/60);
    
    $min = $tmpmin-($hour*60);
} else {
    ($hour,$min,$sec) = &timetaken($startrun,$endrun);
}

if ($fatal == 0) {
    print "<B>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    print "Stats computed in";
	    
    print " $hour h" if ($hour > 0);
    print " $min min";
    print " $sec sec" if ($daystart == $dayend);
    print "</B>\n<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    print "\n\n";
    
    &admin_goback if ($ENV{'REQUEST_METHOD'} eq "GET");
} else {
    
}
#exit(0);

exit;

#----------------------------------------------------
# create_fork
sub create_fork {
    local($string) = @_;

    $cron = fork;
    unless ($cron) {
	exec "$string";
	exit 0;	
    } elsif ($cron != 0) {
	$pid = wait;
    }

}

#----------------------------------------------------
# daily
sub daily {
    local($string,$option,$launch,$launch_time) = @_;

    $string = $w3perlpath.$string.$plext." ".$option;        

    if (($day/$launch) == int($day/$launch) && $hour == $launch_time) {
	push(@list,$string);
	$process_to_launch++;
    }
}

#----------------------------------------------------
# warning
sub warning {
    local($string,$launch_time) = @_;

    $string = $string.$plext;        

    if ($hour_launch != 0) {
	if (($launch_time/$hour_launch) != int($launch_time/$hour_launch)) {
	    print STDERR "$string will never be launch...\n";
    	}
    }
}

#----------------------------------------------------
# Translate Windows Path
sub Windows_ShortPath {
    local($path) = @_;
    
    if ($path =~ /Program Files/i) {
	$path =~ s/Program Files/Progra~1/;
    }
    if ($path =~ /Apache Software Foundation/i) {
	$path =~ s/Apache Software Foundation/Apache~1/;
    }
    return $path;

}

