#!/usr/bin/perl
# <plaintext>  just in case you look at this via a browser

#########################################################################
####                                                                #####
####                  CONFIGURATION USER FILE                       #####
####                                                                #####
####                      (http server)                             #####
####                                                                #####
####                     v 2.996 (01/Aug/2007)                       #####
####                                                                #####
#########################################################################


#########################################################################
###                           Platform used                           ###
#########################################################################

# Just change $type_serveur according to your OS

$type_serveur = 0;  # (0 = Unix ; 1 = Windows; 2 = Domino)
$dirsep = "/";      # path separator (Unix = '/' ; NT = '/' ; Acorn = '.' ; Mac = ':')
$dirsepurl = "/";   # URL separator (same on all platform)

$htmlext = ".html"; # html file extension
$gifext = ".gif";   # gif file extension
$plext = ".pl";     # perl file extension
$zipext = ".gz";    # compression suffix
$carext = ".";     # caractere extension

#########################################################################
###                           Logfile format                          ###
#########################################################################


### Logfile format (http://www.w3perl.com/softs/docs/logformat.html)
# CLF : Common Log File
# ECLF : Extended Common Log File
# NECLF : New Extended Common Log File
# IIS : IIS format (IIS)
# W3C : W3C format (IIS)
# FTP : FTP
# Proxy : Squid format
# Sendmail : Sendmail/Mail format
# Postfix : Postfix/Mail format
# Exim : Exim/Mail format
# RealServer : RealServer
$logfile_format = "Squid";

### Default logfile format string
# This is the default value
# but if you have changed your server configuration, alter this string
# W3C format is automatically extracted from logfile.
# You can also define your own logfile format here
# If you leave this field blank, default value will be used

$struct_logfile = "%date %elapsed %host %codestatus %requetesize %method %page %null %peerstatus %mimetype";

### Logfile filename (http://www.w3perl.com/softs/docs/logfiles.html)
# Fields allowed : 
# %year         [xxxx]
# %smallyear    [xx]
# %month        [00-12]
# %lettermonth  [Jan-Dec]
# %day          [00-31]
# %rotate_index [1-]
# %prefixlog is access
$struct_compressed_logfile = "%prefixlog";

### Virtual server within CLF or ECLF (one logfile for several web server)
$virtualfilter = "";  # select which virtual server you want to parse
$virtualCLF = 0;        # set to 1 if %virtualhost is hidden in %page (%page value begin with http://)

### Date format - IIS server only
# Fields allowed : 
# %year [YY] or [YYYY]
# %month [00-12]
# %day [00-31]
$date_format = "";


### Remote log files
# If you want to retrieve external log
$retrieve_external_log = 0;
$wget_bin = "";
$wget_user = "";
$wget_pass = ''; # simple quote is needed here to avoid perl to evaluate expr
$remote_host_log = "";
$remote_host_port = "80";
$remote_host_dir = "";

#########################################################################
###                 W3Perl Path Configuration                         ###
#########################################################################

## Output path
$path = "/var/w3perl/htdocs/demo-squid/";

## Path where the package have been installed
$pathinit = "/home/domisse/public_html/w3perl/";

## Path where your HTML documents are stored
$pathserver = "/var/w3perl/htdocs/";

## Absolute URL where your HTML documents are located (usually /)
$linkpathserver = "/";

## Cgi-bin path
$cgipath = "/var/w3perl/cgi-bin/";

## Path where log files are located on your server
$fileroot = "/var/w3perl/logs/futurequest/squid/";

## $prefixlog is the name of your log file (located in $fileroot)
## $referlog, $agentlog and $errorlog are the name of your referer,
## your agent log and error file if you have one.
## If you have the extented common log file,
## $agentlog and $referlog have the same value as $prefixlog.
$prefixlog = "access";
$referlog = "";
$agentlog = "";
$errorlog = "";

## Fly path (graphic tool)
$FLY = "/var/w3perl/cgi-bin/fly";

## Gunzip or unzip path (decompression tool)
$GZIP = " -dc";

#########################################################################
###                    W3Perl Exportation                             ###
#########################################################################

### PDF
$enable_pdf = 0;
$HTMLDOC = "";   # Convert html to pdf

### Email
$enable_email = 0;   # email report
$emailadr = "";               # your email here
$email_smtp = "localhost";   # smtp server to send email
$email_smtp_port = 25;  # smtp server port
$email_html = 0;       # send html report
$email_pdf = 0;         # send pdf report
$email_daily = 0;     # daily email report
$email_weekly = 0;   # weekly email report
$email_monthly = 0; # monthly email report


#########################################################################
###                    W3Perl Configuration                           ###
#########################################################################

## WWW server address
$localserver = "127.0.0.1";

## Directory filter
$tri = "/";

## Filtering only one country - use country extension
$country_filtering = "";

## Hosts to filter
## '.ens.fr' reject the ens.fr domain
## '.fr' reject all french hosts
@nolog = ();

## full detailled stats for these html pages (URL from your Document root)
@selection = ();

## Subdirectories with graphical stats output
## (URL from your Document root)
@selecrepert = ();

## Excluding subdirectories from your report
## (URL from your Document root)
@excluderepert = ();

## Virtual server to exclude (available for NECLF)
@excludevirtual = ();

## Status code to exclude (status 400 and beyond are filtered by default)
@excludestatuscode = ();

## Global variables
$precision = 3;     # level of accuracy (from 1 (basic) to 4 (huge))
$show_all = 0;       # will also display all items
$locallog = 0;      # local access log (0 = no = exclude local log)
$localonly = 0;     # only local access log (1 = yes = only local log)
$zip = 0;           # compressed log files (1 = yes)
$zipcut = 0;        # split log files : 0 => no ; 1 => monthly ; 2 => daily ; 3 => apache rotation
$topten = 10;       # Show only  best items
$seuilpage = 10;    # Show pages with more than  requests
$seuilsite = 10;    # Show hosts with more than  requests
$seuilscript = 10;  # Show scripts with more than  requests
$seuilrepert = 100; # displaying directories with more than  requests
$optdirsize = 4;    # directories traffic graphs [html pages ( 1 : total, 2 : external, 3 : local), all files ( 4 : total, 5 : external, 6 : local)]
$nbdays = 50;       # number of days to display for graphs

@extension = ('html','php');    # html pages extensions to parse, ('') mean html files have no extension
@extensionimage = ('gif','jpg','png'); # images extensions to parse

$reverse_dns = 1; # Reverse IP to name (slow down computing by a large amount)
$reverse_geo = 0; # Map IP to country code (need to get the perl module installed)
$netgeo = 0;
$geoip_free = 0;

$titlename = 0;   # convert URL to title (0 =  no)
$defaulthomepage = "index.html"; # request on '/' means request on 'index.html'

## $localdomainename is your domain name
## add your IP adresses if your hosts don't have a DNS
## ^ mean 'begin with', $ mean 'end with', put \ before any dot (using regex)
## Ex : ^145.238.44.* (all hosts inside 145.238.44. are domain hosts)
$localdomainename = "127.0.0.1";
$localdomaine = "127.0.0.1";

$tildealias = "public_html";   # your aliases for users HTML directory
#$yellowfile = "";   # Yellow pages NIS if available
$exclude_frame = 0; # set to 1 to exclude framed page
$exclude_robot = 0; # set to 1 to exclude robot 
$exclude_refererspam = 0; # set to 1 to exclude referer spammer 

# Spip engine used ?
$spip = 0; # set to 1 if you are using a spip engine

#########################################################################
###                         w3perl output                             ###
#########################################################################

# Choose languages output (@lang and @homepages must have the same number of elements)
# @homepages filename should be different from each other (else it will be overwritten !)
@homepages = ('index');
@lang = ('uk');

# Your own link in the top frame
$topframelinks = "<A HREF='http://$localserver$tri' TARGET='_top'>Home</A>";

# Choose between vertical or horizontal frame
$frame_updown = 1;

### Graphical output

$bargraph = 0;  # bar chart
$tridim = 1;    # 3d bar chart
$linegraph = 0; # line
$fillgraph = 0; # line filled

# custom colours for links and background, graphs size (now deprecated with w3perl.css)
$custom_text = "#000099";  # text color
$custom_link = "#000080";  # link color
$custom_vlink = "#800000"; # visited link color

# choose either a BGCOLOR or/and a BACKGROUND images
$bgcolor = "#FFFFFF";
$background = "";

# choose to display your own logo file
# file is located in /w3perl/resources/ or use absolute URL
$logo = "logo.png";

#########################################################################
###    Choose which part of script should work (1 = on, 0 = off)      ###
#########################################################################

# Scripts running
$actif_inc = 1;
$actif_real = 1;
$actif_hour = 1;
$actif_day = 1;
$actif_week = 1;
$actif_month = 1;
$actif_year = 0;
$actif_agent = 0;
$actif_refer = 0;
$actif_session = 1;
$actif_error = 0;
$actif_history = 0;
$actif_url = 0;

# Scripts running every n day
$inc_launch = 1;
$hour_launch = 1;
$day_launch = 1;
$week_launch = 1;
$month_launch = 1;
$refer_launch = 1;
$agent_launch = 1;
$error_launch = 1;
$session_launch = 1;
$url_launch = 7;
$history_launch = 1;

# Scripts option
$option_pages = "";
$option_inc = "";
$option_real = "";
$option_hour = "";
$option_day = "";
$option_week = "-g line";
$option_month = "";
$option_year = "";
$option_agent = "";
$option_refer = "";
$option_session = "-d 10";
$option_error = "-k";
$option_history = "";
$option_url = "";


# Hour when scripts are running 
$inc_launch_time = 0;
$inc_launch_time_min = 0;
$hour_launch_time = 0;
$day_launch_time = 0;
$week_launch_time = 0;
$month_launch_time = 0;
$agent_launch_time = 0;
$refer_launch_time = 0;
$error_launch_time = 0;
$session_launch_time = 0;
$url_launch_time = 0;
$history_launch_time = 0;

$week_launch_day = 1;
$month_launch_day = 1;


# cron-url.pl
$url_frame = 0;         # Framed HTML pages
$url_doublon = 0;       # HTML pages with same TITLE tag or without
$url_absolute_link = 0; # List of absolute links to avoid
$url_symbolic_link = 0; # List of symbolics link (Unix)
$url_bad_link = 1;      # List of wrong links
$url_useless = 0;       # List of HTML pages never link from
$url_directory = 1;     # Stats about directories
$url_weight = 1;        # Stats about the most heavy pages
$url_link = 1;          # Stats about number of links in HTML pages
$url_image = 1;         # Stats about number of images in HTML pages
$url_new_doc = 1;       # New HTML pages on your server
$url_cdrom = 0;         # Show HTML pages without index.html link
$url_img_tag = 0;       # Images without ALT or having bad WIDTH and HEIGHT tags
$url_tree = 1;          # Show server tree


# cron-session.pl
$session_connection = 1;  # Average reading time
$session_visit = 1;       # Show the number of visits by day
$session_average = 1;     # Show average load versus hour and day of the week
$session_login = 0;       # Show people accessing password protected area
$session_description = 1; # List of session by hosts
$session_engine = 0;      # List of robots scanning your web
$session_reading = 0;      # Average reading time per page


# cron-pages.pl and cron-inc.pl
$inc_host = 1;      # not yet implemented
$inc_page = 1;      # not yet implemented
$inc_directory = 1; # not yet implemented
$inc_country = 1;   # not yet implemented
$inc_script = 1;    # Stats about the scripts used and the parameters used
$inc_virus = 0;    # Stats about virus
$inc_download_aborted = 0;    # Stats about incomplete download

#-
#----------------------------------------------------------------------------#
#-                         Stop here for configuration                      -#
#-                  You should not modify anything after this line          -#
#----------------------------------------------------------------------------#
#-

#########################################################################
###                      w3perl global variables                      ###
#########################################################################
###                                                                   ###
###           Ne pas modifier !!! - Don't modify !!!                  ###

### checking few things

if ($zip == 1) {
    ($tmp) = split(/ /,$GZIP);
#    $tmp = $GZIP;
#    $tmp =~ s/\s+\-dc\s*//;
    if (!(-x $tmp)) {
        $error_msg .= "Unable to find your compression tool in $tmp\n";
        &error_config($error_msg);
    }
}

if ($FLY ne '') {
    if (!(-x $FLY)) {
	$error_msg .= "Unable to find the graphic tool FLY in $FLY\n";
	&error_config($error_msg);
    }
}

if ($HTMLDOC ne '' && $enable_pdf == 1) {
    if (!(-x $HTMLDOC)) {
	$error_msg .= "Unable to find the pdf tool in $HTMLDOC\n";
	&error_config($error_msg);
    }    
}

if ($titlename == 1 && $actif_url == 0) {
    $error_msg = "You should run the cron-url script in order to use URL mapping\n";
    $error_msg .= "Set \$actif_url = 1 in your configuration file\n";
    &error_config($error_msg);    
}

if ($locallog == 0 && $localonly == 1) {
    $error_msg .= "You have to enable \$locallog = 1 if you choose to get only domain stats\n";
    &error_config($error_msg);
}

if ($#homepages == -1) {
    $error_msg .= "You have to choose at least one language to get stats output !\n";
    &error_config($error_msg);
}

if ($topten < 1) {
    $error_msg .= "\$topten should be different than 0\n";
    &error_config($error_msg);
}


if ($retrieve_external_log == 1) {
    if (!(-x $wget_bin)) {
	$error_msg .= "Unable to find the wget tool $wget_bin\n";
	&error_config($error_msg);
    }
    $wget_pass =~ s/(\W)/\\$1/g;
#    $wget_login =~ s/([^A-Za-z0-9])/sprintf("%%%02X", ord($1))/seg if ($wget_login ne '');
#    $wget_pass =~ s/([^A-Za-z0-9])/sprintf("%%%02X", ord($1))/seg if ($wget_pass ne '');
    if ($remote_host eq '') {
        $error_msg .= "No remote host specified to retrieve remote logfiles\n";
	&error_config($error_msg);
    }
}

###

sub error_config {
    local($msg) = @_;

    if ($ENV{'REQUEST_METHOD'} eq "GET") {
	print "Content-type: text/html\n\n";
       # Adding CSS style
        print "<style type=\"text/css\">\n";
        print "body {\n";
        print "background-color: #FCFCFC;\n";
        print "color: #202020;\n";
        print "margin: 10px;\n";
        print "font-family: Verdana, Geneva, Arial, sans-serif;\n";
        print "font-size: small;\n";
        print "}\n";
        print "ul {\n";
        print "list-style-type: square;\n";
        print "padding:0px 5px;\n";
        print "}\n";
        print ".error_exit {\n";
        print "color: #FF0000;\n";
        print "font-weight: bold;\n";
        print "}\n";
        print ".launch_title {\n";
        print "color: #30A030;\n";
        print "font-weight: bold;\n";
        print "}\n";
        print "</style>\n";
    }
    print "ERROR in configuration file\n";
    print "<DIV CLASS=\"error_exit\">" if ($ENV{'REQUEST_METHOD'} eq "GET");
    $msg =~ s/\n/\<BR\>/g if ($ENV{'REQUEST_METHOD'} eq "GET");
    print "$msg\n\n";
    print "</DIV>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    exit(1);
}

$reverse_geo = 1 if ($netgeo == 1 || $geoip_free == 1);

### resources and documentation directories (don't modify)

$dirress = "resources";
$dirdocs = "docs".$dirsepurl."uk";
$dirdocs_fr = "docs".$dirsepurl."fr";
$htmldoc_option = "-t pdf --continuous --quiet --no-links --title --textfont helvetica --left 16 --bottom 8 --top 8 --browserwidth 800 --headfootsize 8.0 --fontsize 7.0 --header xtx --footer xd/";

# fly graphic size

$xmax = 450;               # x graph size
$ymax = 250;               # y graph size
$grad = 10;                # number of graduation
$xstep = int($xmax/$grad); # x step for graph
$ystep = int($ymax/$grad); # y step for graph
$xdecal = 75;              # x scale width
$xdecalm = $xdecal - 5;    # length of x scale
$ydecal = 40;              # y scale width
$ydecalm = $ydecal - 15;   # length of y scale

# bubble help size

$help_width = 400;
$popup_graph_width = 120;

### Using default value if $struct_compressed_logfile empty

if ($struct_logfile eq '') {
    if ($logfile_format eq '') {
	$error_msg =  "Can't guess logfile format if you don't specify which kind of logfile you are using !\n";
	&error_config($error_msg);
    }
    $struct_logfile = "%host %null %login %date %hourshift %method %page %protocol %status %requetesize" if ($logfile_format eq "CLF");
    $struct_logfile = "%host %null %login %date %hourshift %method %page %protocol %status %requetesize %referer %agent" if ($logfile_format eq "ECLF");
    $struct_logfile = "%host %null %login %date %hourshift %virtualhost %method %page %protocol %status %requetesize %referer %agent" if ($logfile_format eq "NECLF");
    $struct_logfile = "%host %login %date %hour %null %null %null %elapsed %null %requetesize %status %null %method %page %query" if ($logfile_format eq "IIS");
    $struct_logfile = "%hour %host %method %page %status" if ($logfile_format eq "W3C");
    $struct_logfile = "%host %null %login %date %hourshift %method %page %protocol %status %requetesize %agent" if ($logfile_format eq "RealServer");
    $struct_logfile = "%date %transfert_time %host %requetesize %page %null %null %direction %null %login %method %null %null %status" if ($logfile_format eq "FTP");
    $struct_logfile = "%date %elapsed %host %codestatus %requetesize %method %page %null %peerstatus %mimetype" if ($logfile_format eq "Squid");
    $struct_logfile = "%date %null %module %id %message" if ($logfile_format eq "Mail");
}


### Compressed logfiles

@compressed_logfile_fields = split(/\W+/,$struct_compressed_logfile);
@compressed_sep_fields = split(/\%\w+/,$struct_compressed_logfile);

for ($i=1;$i<=$#compressed_logfile_fields;$i++) {
$compressed_logfile_fields[$i] = "%".$compressed_logfile_fields[$i];
$fields_compressed_logfile{$compressed_logfile_fields[$i]} = $i;
#print STDERR "$i - $compressed_logfile_fields[$i] - $compressed_sep_fields[$i] - $fields_compressed_logfile{$compressed_logfile_fields[$i]}\n"; 
}

### Windows or Unix logfile

$mail_format = 0;
$mail_format = 1 if ($struct_logfile =~ "%module");
$ftp_format = 0;
$ftp_format = 1 if ($struct_logfile =~ "%direction");
$direction = "o" if ($ftp_format == 0 && $mail_format == 0);
$squid_format = 0;
$squid_format = 1 if ($struct_logfile =~ "%codestatus");

if ($tri !~ /\// && $mail_format == 0) {
    $error_msg .= "$tri should be at least '/'\n";
    &error_config($error_msg);
}

# load the logfile format for parsing

@logfile_fields = split(/\s+/,$struct_logfile);

for ($i=0;$i<=$#logfile_fields;$i++) {
    $fields_logfile{$logfile_fields[$i]} = $i;
    $fields_logfile{$logfile_fields[$i]} += 4 if ($ftp_format == 1);
    $fields_logfile{$logfile_fields[$i]} += 2 if ($mail_format == 1 && $logfile_format !~ /exim/i);
#    $fields_logfile{$logfile_fields[$i]} += 2 if ($mail_format == 1);
}

# Check if requetesize is there

$notrafic = 0;
if ($struct_logfile !~ /\%requetesize/ && $mail_format == 0) {
    $notrafic = 1;
    $inc_download_aborted = 0;
}

# checking if IIS logfile format have been selected

# Common (Unix)
$iis_format = 0;
$logfile_sep = "[ ]+";
#$logfile_sep = "[ ]+" if ($squid_format == 1);

if ($squid_format == 0 && $ftp_format == 0) { 
if ($prefixlog eq "ex" || $prefixlog eq "in" || $logfile_fields[0] eq "%date" || ($logfile_fields[4] eq "%null" && $logfile_fields[5] eq "%null")) {

 # IIS (Windows)
    $iis_format = 1;
    $type_serveur = 1;
    @date_string = split(/%/,$date_format);

    $logfile_sep = ", " if ($logfile_fields[1] eq "%login"); # Standard
    $logfile_sep = " " if ($logfile_fields[1] ne "%login");

}
}

# checking extended or common logfile format

if ($struct_logfile =~ "%referer") {
    $referlog = $prefixlog; # for extented common logfile (NCSA > 1.4)
}

if ($struct_logfile =~ "%agent") {
    $agentlog = $prefixlog; # for extented common logfile (NCSA > 1.4)
}

### yellow pages

if ($yellowfile ne '') {
open(NIS,"$yellowfile") || die "Error, unable to open $yellowfile\n";
while (<NIS>) {
($a,$b) = split;
$nis{$a} = $b;
}
close(NIS);
}

### init

for ($i=0;$i<=$#extension;$i++) {
    $extension .= "$carext".$extension[$i]."\$|";
}
chop($extension);

if ($ftp_format == 0 && $mail_format == 0) {
    if (scalar(@extension) == 0) {
    $error_msg = "You should give at least one extension to map html files\n";
    $error_msg .= "If your files have no extension, use the \'\' for empty value";
    &error_config($error_msg);
    }
    if ($extension =~ /\.\$/) {
       $extension =~ s/\.\$//;
       $extension =~ s/^\|//;
       $nohtmlext = 1;
       }
}

$exclude_refererspam = 0 if ($struct_logfile !~ /\%refer/);

#$maxlengthos = 10; # Maximum length filename (Mac = 31) 

# find the name of the package

$tmp = $path;
chop($tmp);
$pos = rindex($tmp,$dirsep);
$packagename = substr($tmp,$pos+1,length($tmp));

# global variables

$localdomaine =~ tr/A-Z/a-z/;
$stop = 0;
$nbdays = 1 if ($nbdays < 0);
#$nbdays = 366 if ($nbdays == 0 || $nbdays > 366);

$pi = atan2(1,1)*4;
$piradiant = $pi/180;
$halfxmax = $xmax/2;
$halfymax = $ymax/2;
$diam = $ymax;
$rayon = $diam/2;

# homepages filename

@homepagesframed = ('');
for ($nblang=0;$nblang<=$#homepages;$nblang++) {
        $homepagesframed[$nblang] = $homepages[$nblang]."2".$htmlext;
        $homepages[$nblang] = $homepages[$nblang].$htmlext;
}

# graphic flags

for ($nblang=0;$nblang<=$#homepages;$nblang++) {
$flag[$nblang] = "flag-".$lang[$nblang].$gifext;
}

# graphic option

@graphic = ('bar','3d','line','fill'); 
$bargraph = 1 if ($tridim == 1);
$linegraph = 1 if ($fillgraph == 1);
$perspec = 5; # perpective view for 3D graph

### output directories
### Sous NT, on calcule $linkpathinit 
### Sous Unix, $linkpathinit = '' car lien symbolique

$linkpathinit = '';

if ($type_serveur == 1) {
    if ($pathinit =~ /\/(\w+)\/$tildealias/ && $tildealias ne '') {
         $tmp2 = $1;
         $tmp3 = $';
    } else {
    $pos = rindex($path,$dirsep);
    $pos2 = index($pathinit,$path);
    $tmp = $path;
    while ($pos2 == -1) {
	$pos = rindex($tmp,$dirsep,$pos-1);
	$tmp = substr($tmp,$dirsep,$pos+1);
	$linkpathinit .= "..$dirsepurl";
	$pos2 = index($pathinit,$tmp);
    }
    $b = substr($pathinit,$pos+1);
    chop($b);
    $linkpathinit .= "$b$dirsepurl" if ($b ne '');
    }

    if ($linkpathinit =~ /$tildealias/ && $tildealias ne '') {

    $pos = rindex($path,$dirsep);
    $pos2 = index($pathserver,$path);
    $tmp = $path;
    while ($pos2 == -1) {
	$pos = rindex($tmp,$dirsep,$pos-1);
	$tmp = substr($tmp,$dirsep,$pos+1);
	$linkpathinit .= "..$dirsepurl";
	$pos2 = index($pathserver,$tmp);
    }

    $linkpathinit .= "~$tmp2$tmp3";
    }
}

$homeicons = $linkpathinit;
$homeicons .= $dirress.$dirsepurl."homepage";

$backgrd = "BGCOLOR=\"$bgcolor\"";         # color background
$backgrd .= " BACKGROUND=\"$background\"" if ($background ne '');

$dirdata = "data";
$dirdate = "date";
$dirdays = "days";
$dirlist = "list";
$dirscript = "script";
$dirtmp = "tmp";
$dirframe = "frame";
$dirinc = "inc";
$dirpays = "pays";
$dirsite = "site";
$dirpage = "page";
$dirsession = "session";
$dirdocument = "document";
$dirproxy = "proxy";
$dirgraph = "graph";
$tmpfly = $path.$dirtmp.$dirsep."tmpfly";
$history = $path.$dirdata.$dirsep."history";
$filecpu = "cpu".$htmlext;
$baudrate = 5;       

## building string match for speed

for ($i=0;$i<=$#nolog;$i++) {
    $nolog .= $nolog[$i]."|";
    }
chop($nolog);

for ($i=0;$i<=$#selection;$i++) {
    $selection .= $selection[$i]."|";
    }
chop($selection);


for ($i=0;$i<=$#excluderepert;$i++) {
    $excluderepert .= $excluderepert[$i]."|";
    }
chop($excluderepert);

for ($i=0;$i<=$#excludestatuscode;$i++) {
    if ($excludestatuscode[$i] < 400 && $excludestatuscode[$i] != 301 && $excludestatuscode[$i] != 302 && $excludestatuscode[$i] != 304) {
    $excludestatuscode .= $excludestatuscode[$i]."|";
}
    }
chop($excludestatuscode);

$rss_file = '';
for ($i=0;$i<=$#rss_file;$i++) {
    $rss_file .= "^".$rss_file[$i]."|";
    }
chop($rss_file);


for ($i=0;$i<=$#excludevirtual;$i++) {
    $excludevirtual .= $excludevirtual[$i]."|";
    }
chop($excludevirtual);

## colors table

# for fly output

$square = 10;         # images are $square square pixels
@gcolor = ('rouge','vert','bleufonce','bleu','violet','jaune','marron','vertfonce','bleunuit','bleuclair','jaunefonce','kaki','orange','rose');
@flycolor = (255,85,85,85,255,85,85,85,255,85,255,255,255,85,255,255,255,85,170,0,0,0,170,0,0,0,170,74,213,172,197,213,41,156,180,0,238,148,0,189,131,131);


for ($i=0;$i<$#gcolor;$i++) {
    $gcolor[$i] .= $gifext;

    $red[$i] = $flycolor[3*$i];
    $green[$i] = $flycolor[3*$i+1];
    $blue[$i] = $flycolor[3*$i+2];
    }

undef @flycolor;

# last color index is 100 (others.gif)

$red[100] = 102;
$green[100] = 102;
$blue[100] = 102;

$diros = "os";

##################################################################
### generic file names
##################################################################

$favicon = "favicon";
$pngext = ".png";
$icoext = ".ico";
$txtext = ".txt";
$csvext = ".csv";

### Logo file
# if you want to use your own logo ...
# default is a png file located in /resources/

$logo = "logo".$pngext if ($logo eq '');

### Data files ###

$file = $fileroot.$prefixlog; # a supprimer
$fileagent = $fileroot.$agentlog;
$filerefer = $fileroot.$referlog;

$help = "index.html";
#$drawstat = "stats".$gifext;
#$drawstatsmall = "statsmall".$gifext;
$paysgraph = "pays".$gifext;
$paysgraph2 = "pays2".$gifext;
$paysconv = "pays-conv";
$fileurl = "listeurl";
$ip_table = "ip";

#

$datafile = "time-stat";
$statrepert = "time-repert";
$filerepertsize = "time-rsize";

#

$filenamehour = "stat-hour".$htmlext;
$filenameday = "stat-day".$htmlext;
$statnameweek = "stat-week".$htmlext;
$statnamemonth = "stat-month".$htmlext;

$filenametabsize = "tab-size".$htmlext;

# 

$tabnamedays = "tab-days".$htmlext;
$tabnameweek = "tab-weeks".$htmlext;
$tabnamemonth = "tab-month".$htmlext;
$tabnamerefer = "refer".$htmlext;
$tabnamekeyword = "keyword".$htmlext;
$tabnamebrowser = "agent".$htmlext;
$tabnameerror = "error".$htmlext;

# version incrementale

$incgeneral = "general";
$incpage = "pages";
$incpays = "pays";
#$incservtot = "serv-tot";
$incservexterne = "serv-externe";
$incservinterne = "serv-interne";
$incpageselect = "pages-select";
$increpert = "repert";
$inchosts = "hosts";
$incscript = "script";
$incproxystatus = "proxy-status";
$incproxypeer = "proxy-peer";
$incproxyhosts = "proxy-host";

$increfengine = "refengine";
$increfkey = "refkey";
$increfsites = "refsite";
$increfpages = "refpages";
$increfin = "refin";
$increfselec = "refselec";
$increfexit = "refexit";

$incbrowser = "browser";
$incos = "os";
$dayagent = "dayagent";

$incerror = "error";
$incerrpage = "errpage";
$dayerror = "dayerror";

$incrobot = "robot";
$incvirtual = "virtual";

$incstatus = "status";
$incabort = "abort";
$incftp = "ftp";

## nom des fichiers dans le repertoire Ressources

$refer = "refer".$htmlext;
$agent = "agent".$htmlext;
$error = "error".$htmlext;
$filesession = "index".$htmlext;
$menu = "index".$htmlext;
$filemoyenne = "moyenne".$htmlext;
$fileresumemenu = "menu".$htmlext;

# graphs used by pages and computed by week
$statweekrepert = "week_rep";

#### a supprimer ????

$file_now = "now".$htmlext;
$filehour = "stat-hour".$htmlext;
$fileday = "stat-day".$htmlext;
$fileweek = "stat-week".$htmlext;
$filemonth = "stat-month".$htmlext;

#

$filesites = "index".$htmlext;
$filepages = "index".$htmlext;
$filepays = "index".$htmlext;
$filerepert = "list-report".$htmlext;
$filescript = "index".$htmlext;

$filereport = $filerepert;  # a supprimer
$filevirtual = "virtual".$htmlext;

$topframe = "top".$htmlext;
$bottomframe = "bottom".$htmlext;

$unresolved = "unresolved".$htmlext;

# icons

$icon_hosts = "hosts".$pngext;
$icon_countries = "countries".$pngext;
$icon_pages = "pages".$pngext;
$icon_dir = "dir".$pngext;
$icon_hours = "hours".$pngext;
$icon_days = "days".$pngext;
$icon_weeks = "weeks".$pngext;
$icon_months = "months".$pngext;
$icon_refer = "refer".$pngext;
$icon_spider = "spider".$pngext;
$icon_session = "session".$pngext;
$icon_error = "error".$pngext;
$icon_agent = "agent".$pngext;
$icon_doc = "document".$pngext;
$icon_script = "script".$pngext;
$icon_virtual = "virtual".$pngext;
$icon_filetype = "filetype".$pngext;
$icon_screensize = "screensize".$pngext;
$icon_traffic = "traffic".$pngext;
$icon_virus = "virus".$pngext;
$icon_squid = "squid".$pngext;
$icon_status = "status".$pngext;
$icon_destination = "destination".$pngext;

$icon_tree = "tree".$pngext;
$icon_new = "new".$pngext;
$icon_linksym = "linksym".$pngext;
$icon_linkerr = "linkerr".$pngext;
$icon_docrepert = "docrepert".$pngext;
$icon_useless = "useless".$pngext;
$icon_linkabs = "linkabs".$pngext;
$icon_info = "info".$pngext;
$icon_info2 = "info2".$pngext;
$icon_temp = "temp".$pngext;
$icon_verif = "verif".$pngext;
$icon_pie = "pie".$pngext;
$icon_null = "null".$pngext;
$icon_links = "links".$pngext;
$icon_ima = "ima".$pngext;
$icon_trash = "trash".$pngext;
$icon_cdrom = "cdrom".$pngext;

$icon_duree = "duree".$pngext;
$icon_notes = "notes".$pngext;
$icon_descsess = "descsess".$pngext;
$icon_sessmul = "sessmul".$pngext;
$icon_time = "time".$pngext;
$icon_unread = "unread".$pngext;
$icon_login = "login".$pngext;
$icon_users = "users".$pngext;
$icon_reading = "reading".$pngext;

$icon_new_w3perl = "new_stat".$gifext;
$icon_fleched = "fleched".$pngext;
$icon_flecheg = "flecheg".$pngext;
$icon_flecheh = "flecheh".$pngext;
$icon_go = "go".$pngext;

$icon_weight = "weight".$pngext;
$icon_moyenne = "moyenne".$pngext;

$icon_pdf = "pdf".$pngext;
$icon_csv = "csv".$pngext;
$icon_print = "print".$pngext;
$icon_mail = "mail".$pngext;

$dirdomain = "domain";
$dirdownload = "download";
$earthmap = "earth.jpg";

$extconv = "fileext";
$filetype = "filetype";

$dirflags = "flags";
$pagedate = "pagedate";
$pagehas = "pagehas";

$dirtraffic = "traffic";
$filevirus = "virus".$htmlext;
$virusdef = "virus";
$filesquid = "squid".$htmlext;

$icon_help = "help".$gifext;
$dirhelp = "help";

$doctype = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">";
$charset = "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">";

$dircsv = "csv";
$dirpdf = "pdf";
$dirjs = "js";
$dircss = "css";

$sorttablejs = "sorttable.js";
$helpjs = "help.js";
$calendarjs = "basiccalendar.js";

$css_w3perl = "w3perl.css";
$css_help = "help.css";

$refspam_ip = "referrer-ip.txt";
$refspam_standard = "referrer-standard.txt";
$increferspam = "referer_spam";

$filescreensize = "screensize".$htmlext;

$miscstats_string = "/stats_w3perl_screensize/miscstats.js";
$incscreensize = "screensize";

$users = "users";
$pdfext = ".pdf";
@selection = () if ($mail_format == 1);

$searchjs = "search.js";
$incpagehost = "pagehost";

# What's new - [3.003]
$toggle_on = "chkCheckAll.gif";
$toggle_off = "chkUnCheckAll.gif";
$incpagehost = "pagehost";

$nb_rss_item = 20;
$icon_mini_rss = "rss".$pngext;
$icon_rss = "rss".$pngext;
$filerss= "rss";
$xmlext = ".xml";
$dirxml = "xml";
# What's new - [3.001]
$searchjs = "search.js";
$popup_graph_width = 120;

# What's new - [3.003]
$toggle_on = "chkCheckAll.gif";
$toggle_off = "chkUnCheckAll.gif";
$incpagehost = "pagehost";

# What's new - [3.005]
$rss_file = '';
for ($i=0;$i<=$#rss_file;$i++) {
    $rss_file .= "^".$rss_file[$i]."|";
    }
chop($rss_file);
$nb_rss_item = 20;
$icon_mini_rss = "rss".$pngext;
$icon_rss = "rss".$pngext;
$filerss= "rss";
$xmlext = ".xml";
$dirxml = "xml";



# What's new - [3.007]
$tabnameyear = "tab-year".$htmlext;
$statnameyear = "stat-year".$htmlext;
$icon_year = "year".$pngext;
$icon_xml = "xml".$pngext;
$icon_hacker = "hacker".$pngext;
$icon_spam = "spam".$pngext;
$icon_bounce = "bounce".$pngext;

$year_launch = 1;
$year_launch_time = 0;

1;
