#-
#----------------------------------------------------------------------------#
#-                         Stop here for configuration                      -#
#-                  You should not modify anything after this line          -#
#----------------------------------------------------------------------------#
#-

#########################################################################
###                      w3perl global variables                      ###
#########################################################################
###                                                                   ###
###           Ne pas modifier !!! - Don't modify !!!                  ###

### checking few things

if ($zip == 1) {
    ($tmp) = split(/ /,$GZIP);
#    $tmp = $GZIP;
#    $tmp =~ s/\s+\-dc\s*//;
    if (!(-x $tmp)) {
        $error_msg .= "Unable to find your compression tool in $tmp\n";
        &error_config($error_msg);
    }
}

if ($FLY ne '') {
    if (!(-x $FLY)) {
	$error_msg .= "Unable to find the graphic tool FLY in $FLY\n";
	&error_config($error_msg);
    }
}

if ($HTMLDOC ne '' && $enable_pdf == 1) {
    if (!(-x $HTMLDOC)) {
	$error_msg .= "Unable to find the pdf tool in $HTMLDOC\n";
	&error_config($error_msg);
    }    
}

if ($titlename == 1 && $actif_url == 0) {
    $error_msg = "- You should run the cron-url script in order to use URL mapping\n";
    $error_msg .= " => Set \$actif_url = 1 in your configuration file\n";
    $error_msg .= "or\n- Disable URL mapping\n => Set \$titlename = 0 in your configuration file\n";
    &error_config($error_msg);    
}

if ($locallog == 0 && $localonly == 1) {
    $error_msg .= "You have to enable \$locallog = 1 if you choose to get only domain stats\n";
    &error_config($error_msg);
}

if ($#homepages == -1) {
    $error_msg .= "You have to choose at least one language to get stats output !\n";
    &error_config($error_msg);
}

if ($topten < 1) {
    $error_msg .= "\$topten should be different than 0\n";
    &error_config($error_msg);
}


if ($retrieve_external_log == 1) {
    if (!(-x $wget_bin)) {
	$error_msg .= "Unable to find the wget tool $wget_bin\n";
	&error_config($error_msg);
    }
    $wget_pass =~ s/(\W)/\\$1/g;
#    $wget_login =~ s/([^A-Za-z0-9])/sprintf("%%%02X", ord($1))/seg if ($wget_login ne '');
#    $wget_pass =~ s/([^A-Za-z0-9])/sprintf("%%%02X", ord($1))/seg if ($wget_pass ne '');
    if ($remote_host eq '') {
        $error_msg .= "No remote host specified to retrieve remote logfiles\n";
	&error_config($error_msg);
    }
}

###

sub error_config {
    local($msg) = @_;

    if ($ENV{'REQUEST_METHOD'} eq "GET") {
	print "Content-type: text/html\n\n";
       # Adding CSS style
        print "<style type=\"text/css\">\n";
        print "body {\n";
        print "background-color: #FCFCFC;\n";
        print "color: #202020;\n";
        print "margin: 10px;\n";
        print "font-family: Verdana, Geneva, Arial, sans-serif;\n";
        print "font-size: small;\n";
        print "}\n";
        print "ul {\n";
        print "list-style-type: square;\n";
        print "padding:0px 5px;\n";
        print "}\n";
        print ".error_exit {\n";
        print "color: #FF0000;\n";
        print "font-weight: bold;\n";
        print "}\n";
        print ".launch_title {\n";
        print "color: #30A030;\n";
        print "font-weight: bold;\n";
        print "}\n";
        print "</style>\n";
    }
    print "ERROR in configuration file\n";
    print "<DIV CLASS=\"error_exit\">" if ($ENV{'REQUEST_METHOD'} eq "GET");
    $msg =~ s/\n/\<BR\>/g if ($ENV{'REQUEST_METHOD'} eq "GET");
    print "$msg\n\n";
    print "</DIV>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    exit(1);
}

$reverse_geo = 1 if ($netgeo == 1 || $geoip_free == 1);

### resources and documentation directories (don't modify)

$dirress = "resources";
$dirdocs = "docs".$dirsepurl."uk";
$dirdocs_fr = "docs".$dirsepurl."fr";
$htmldoc_option = "-t pdf --continuous --quiet --no-links --title --textfont helvetica --left 16 --bottom 8 --top 8 --browserwidth 800 --headfootsize 8.0 --fontsize 7.0 --header xtx --footer xd/";

# fly graphic size

$xmax = 450;               # x graph size
$ymax = 250;               # y graph size
$grad = 10;                # number of graduation
$xstep = int($xmax/$grad); # x step for graph
$ystep = int($ymax/$grad); # y step for graph
$xdecal = 75;              # x scale width
$xdecalm = $xdecal - 5;    # length of x scale
$ydecal = 40;              # y scale width
$ydecalm = $ydecal - 15;   # length of y scale

# bubble help size

$help_width = 400;
$popup_graph_width = 120;

### Using default value if $struct_compressed_logfile empty

if ($struct_logfile eq '') {
    if ($logfile_format eq '') {
	$error_msg =  "Can't guess logfile format if you don't specify which kind of logfile you are using !\n";
	&error_config($error_msg);
    }
    $struct_logfile = "%host %null %login %date %hourshift %method %page %protocol %status %requetesize" if ($logfile_format eq "CLF");
    $struct_logfile = "%host %null %login %date %hourshift %method %page %protocol %status %requetesize %referer %agent" if ($logfile_format eq "ECLF");
    $struct_logfile = "%host %null %login %date %hourshift %virtualhost %method %page %protocol %status %requetesize %referer %agent" if ($logfile_format eq "NECLF");
    $struct_logfile = "%host %login %date %hour %null %null %null %elapsed %null %requetesize %status %null %method %page %query" if ($logfile_format eq "IIS");
    $struct_logfile = "%hour %host %method %page %status" if ($logfile_format eq "W3C");
    $struct_logfile = "%host %null %login %date %hourshift %method %page %protocol %status %requetesize %agent" if ($logfile_format eq "RealServer");
    $struct_logfile = "%date %transfert_time %host %requetesize %page %null %null %direction %null %login %method %null %null %status" if ($logfile_format eq "FTP");
    $struct_logfile = "%date %elapsed %host %codestatus %requetesize %method %page %null %peerstatus %mimetype" if ($logfile_format eq "Squid");
    $struct_logfile = "%date %null %module %id %message" if ($logfile_format eq "Mail");
}


### Compressed logfiles

@compressed_logfile_fields = split(/\W+/,$struct_compressed_logfile);
@compressed_sep_fields = split(/\%\w+/,$struct_compressed_logfile);

for ($i=1;$i<=$#compressed_logfile_fields;$i++) {
$compressed_logfile_fields[$i] = "%".$compressed_logfile_fields[$i];
$fields_compressed_logfile{$compressed_logfile_fields[$i]} = $i;
#print STDERR "$i - $compressed_logfile_fields[$i] - $compressed_sep_fields[$i] - $fields_compressed_logfile{$compressed_logfile_fields[$i]}\n"; 
}

### Windows or Unix logfile

$mail_format = 0;
$mail_format = 1 if ($struct_logfile =~ "%module");
$ftp_format = 0;
$ftp_format = 1 if ($struct_logfile =~ "%direction");
$direction = "o" if ($ftp_format == 0 && $mail_format == 0);
$squid_format = 0;
$squid_format = 1 if ($struct_logfile =~ "%codestatus");

if ($tri !~ /\// && $mail_format == 0) {
    $error_msg .= "$tri should be at least '/'\n";
    &error_config($error_msg);
}

# load the logfile format for parsing

@logfile_fields = split(/\s+/,$struct_logfile);

for ($i=0;$i<=$#logfile_fields;$i++) {
    $fields_logfile{$logfile_fields[$i]} = $i;
    $fields_logfile{$logfile_fields[$i]} += 4 if ($ftp_format == 1);
    $fields_logfile{$logfile_fields[$i]} += 2 if ($mail_format == 1 && $logfile_format !~ /exim/i);
#    $fields_logfile{$logfile_fields[$i]} += 2 if ($mail_format == 1);
}

# Check if requetesize is there

$notrafic = 0;
if ($struct_logfile !~ /\%requetesize/ && $mail_format == 0) {
    $notrafic = 1;
    $inc_download_aborted = 0;
}

# checking if IIS logfile format have been selected

# Common (Unix)
$iis_format = 0;
$logfile_sep = "[ ]+";
#$logfile_sep = "[ ]+" if ($squid_format == 1);

if ($squid_format == 0 && $ftp_format == 0) { 
if ($prefixlog eq "ex" || $prefixlog eq "in" || $logfile_fields[0] eq "%date" || ($logfile_fields[4] eq "%null" && $logfile_fields[5] eq "%null")) {

 # IIS (Windows)
    $iis_format = 1;
    $type_serveur = 1;
    @date_string = split(/%/,$date_format);

    $logfile_sep = ", " if ($logfile_fields[1] eq "%login"); # Standard
    $logfile_sep = " " if ($logfile_fields[1] ne "%login");

}
}

# checking extended or common logfile format

if ($struct_logfile =~ "%referer") {
    $referlog = $prefixlog; # for extented common logfile (NCSA > 1.4)
}

if ($struct_logfile =~ "%agent") {
    $agentlog = $prefixlog; # for extented common logfile (NCSA > 1.4)
}

### yellow pages

#if ($yellowfile ne '') {
#open(NIS,"$yellowfile") || die "Error, unable to open $yellowfile\n";
#while (<NIS>) {
#($a,$b) = split;
#$nis{$a} = $b;
#}
#close(NIS);
#}

### init

for ($i=0;$i<=$#extension;$i++) {
    $extension .= "$carext".$extension[$i]."\$|";
}
chop($extension);

if ($ftp_format == 0 && $mail_format == 0) {
    if (scalar(@extension) == 0) {
    $error_msg = "You should give at least one extension to map html files\n";
    $error_msg .= "If your files have no extension, use the \'\' for empty value";
    &error_config($error_msg);
    }
    if ($extension =~ /\.\$/) {
       $extension =~ s/\.\$//;
       $extension =~ s/^\|//;
       $nohtmlext = 1;
       }
}

$exclude_refererspam = 0 if ($struct_logfile !~ /\%refer/);

#$maxlengthos = 10; # Maximum length filename (Mac = 31) 

# find the name of the package

$tmp = $path;
chop($tmp);
$pos = rindex($tmp,$dirsep);
$packagename = substr($tmp,$pos+1,length($tmp));

# global variables

$localdomaine =~ tr/A-Z/a-z/;
$stop = 0;
$nbdays = 1 if ($nbdays < 0);
#$nbdays = 366 if ($nbdays == 0 || $nbdays > 366);

$pi = atan2(1,1)*4;
$piradiant = $pi/180;
$halfxmax = $xmax/2;
$halfymax = $ymax/2;
$diam = $ymax;
$rayon = $diam/2;

# homepages filename

@homepagesframed = ('');
for ($nblang=0;$nblang<=$#homepages;$nblang++) {
        $homepagesframed[$nblang] = $homepages[$nblang]."2".$htmlext;
        $homepages[$nblang] = $homepages[$nblang].$htmlext;
}

# graphic flags

for ($nblang=0;$nblang<=$#homepages;$nblang++) {
$flag[$nblang] = "flag-".$lang[$nblang].$gifext;
}

# graphic option

@graphic = ('bar','3d','line','fill'); 
$bargraph = 1 if ($tridim == 1);
$linegraph = 1 if ($fillgraph == 1);
$perspec = 5; # perpective view for 3D graph

### output directories
### Sous NT, on calcule $linkpathinit 
### Sous Unix, $linkpathinit = '' car lien symbolique

$linkpathinit = '';

if ($type_serveur == 1) {
    if ($pathinit =~ /\/(\w+)\/$tildealias/ && $tildealias ne '') {
         $tmp2 = $1;
         $tmp3 = $';
    } else {
    $pos = rindex($path,$dirsep);
    $pos2 = index($pathinit,$path);
    $tmp = $path;
    while ($pos2 == -1) {
	$pos = rindex($tmp,$dirsep,$pos-1);
	$tmp = substr($tmp,$dirsep,$pos+1);
	$linkpathinit .= "..$dirsepurl";
	$pos2 = index($pathinit,$tmp);
    }
    $b = substr($pathinit,$pos+1);
    chop($b);
    $linkpathinit .= "$b$dirsepurl" if ($b ne '');
    }

    if ($linkpathinit =~ /$tildealias/ && $tildealias ne '') {

    $pos = rindex($path,$dirsep);
    $pos2 = index($pathserver,$path);
    $tmp = $path;
    while ($pos2 == -1) {
	$pos = rindex($tmp,$dirsep,$pos-1);
	$tmp = substr($tmp,$dirsep,$pos+1);
	$linkpathinit .= "..$dirsepurl";
	$pos2 = index($pathserver,$tmp);
    }

    $linkpathinit .= "~$tmp2$tmp3";
    }
}

$homeicons = $linkpathinit;
$homeicons .= $dirress.$dirsepurl."homepage";

$backgrd = "BGCOLOR=\"$bgcolor\"";         # color background
$backgrd .= " BACKGROUND=\"$background\"" if ($background ne '');

$dirdata = "data";
$dirdate = "date";
$dirdays = "days";
$dirlist = "list";
$dirscript = "script";
$dirtmp = "tmp";
$dirframe = "frame";
$dirinc = "inc";
$dirpays = "pays";
$dirsite = "site";
$dirpage = "page";
$dirsession = "session";
$dirdocument = "document";
$dirproxy = "proxy";
$dirgraph = "graph";
$tmpfly = $path.$dirtmp.$dirsep."tmpfly";
$history = $path.$dirdata.$dirsep."history";
$filecpu = "cpu".$htmlext;
$baudrate = 5;       

## building string match for speed

$nolog = '';
for ($i=0;$i<=$#nolog;$i++) {
    $nolog .= $nolog[$i]."|";
    }
chop($nolog);

$selection = '';
for ($i=0;$i<=$#selection;$i++) {
    $selection .= $selection[$i]."|";
    }
chop($selection);

$excluderepert = '';
for ($i=0;$i<=$#excluderepert;$i++) {
    $excluderepert .= $excluderepert[$i]."|";
    }
chop($excluderepert);

$excludestatuscode = '';
for ($i=0;$i<=$#excludestatuscode;$i++) {
    if ($excludestatuscode[$i] < 400 && $excludestatuscode[$i] != 301 && $excludestatuscode[$i] != 302 && $excludestatuscode[$i] != 304) {
    $excludestatuscode .= $excludestatuscode[$i]."|";
}
    }
chop($excludestatuscode);

$rss_file = '';
for ($i=0;$i<=$#rss_file;$i++) {
    $rss_file .= "^".$rss_file[$i]."|";
    }
chop($rss_file);


$excludevirtual = '';
for ($i=0;$i<=$#excludevirtual;$i++) {
    $excludevirtual .= $excludevirtual[$i]."|";
    }
chop($excludevirtual);

## colors table

# for fly output

$square = 10;         # images are $square square pixels
@gcolor = ('rouge','vert','bleufonce','bleu','violet','jaune','marron','vertfonce','bleunuit','bleuclair','jaunefonce','kaki','orange','rose');
@flycolor = (255,85,85,85,255,85,85,85,255,85,255,255,255,85,255,255,255,85,170,0,0,0,170,0,0,0,170,74,213,172,197,213,41,156,180,0,238,148,0,189,131,131);


for ($i=0;$i<$#gcolor;$i++) {
    $gcolor[$i] .= $gifext;

    $red[$i] = $flycolor[3*$i];
    $green[$i] = $flycolor[3*$i+1];
    $blue[$i] = $flycolor[3*$i+2];
    }

undef @flycolor;

# last color index is 100 (others.gif)

$red[100] = 102;
$green[100] = 102;
$blue[100] = 102;

$diros = "os";

##################################################################
### generic file names
##################################################################

$favicon = "favicon";
$pngext = ".png";
$icoext = ".ico";
$txtext = ".txt";
$csvext = ".csv";

### Logo file
# if you want to use your own logo ...
# default is a png file located in /resources/

$logo = "logo".$pngext if ($logo eq '');

### Data files ###

$file = $fileroot.$prefixlog; # a supprimer
$fileagent = $fileroot.$agentlog;
$filerefer = $fileroot.$referlog;

$help = "index.html";
#$drawstat = "stats".$gifext;
#$drawstatsmall = "statsmall".$gifext;
$paysgraph = "pays".$gifext;
$paysgraph2 = "pays2".$gifext;
$paysconv = "pays-conv";
$fileurl = "listeurl";
$ip_table = "ip";

#

$datafile = "time-stat";
$statrepert = "time-repert";
$filerepertsize = "time-rsize";

#

$filenamehour = "stat-hour".$htmlext;
$filenameday = "stat-day".$htmlext;
$statnameweek = "stat-week".$htmlext;
$statnamemonth = "stat-month".$htmlext;
$tabnameyear = "tab-year".$htmlext;
$statnameyear = "stat-year".$htmlext;

$filenametabsize = "tab-size".$htmlext;

# 

$tabnamedays = "tab-days".$htmlext;
$tabnameweek = "tab-weeks".$htmlext;
$tabnamemonth = "tab-month".$htmlext;
$tabnamerefer = "refer".$htmlext;
$tabnamekeyword = "keyword".$htmlext;
$tabnamebrowser = "agent".$htmlext;
$tabnameerror = "error".$htmlext;

# version incrementale

$incgeneral = "general";
$incpage = "pages";
$incpagehost = "pagehost";
$incpays = "pays";
#$incservtot = "serv-tot";
$incservexterne = "serv-externe";
$incservinterne = "serv-interne";
$incpageselect = "pages-select";
$increpert = "repert";
$inchosts = "hosts";
$incscript = "script";
$incproxystatus = "proxy-status";
$incproxypeer = "proxy-peer";
$incproxyhosts = "proxy-host";

$increfengine = "refengine";
$increfkey = "refkey";
$increfsites = "refsite";
$increfpages = "refpages";
$increfin = "refin";
$increfselec = "refselec";
$increfexit = "refexit";

$incbrowser = "browser";
$incos = "os";
$dayagent = "dayagent";

$incerror = "error";
$incerrpage = "errpage";
$dayerror = "dayerror";

$incrobot = "robot";
$incvirtual = "virtual";

$incstatus = "status";
$incabort = "abort";
$incftp = "ftp";

## nom des fichiers dans le repertoire Ressources

$refer = "refer".$htmlext;
$agent = "agent".$htmlext;
$error = "error".$htmlext;
$filesession = "index".$htmlext;
$menu = "index".$htmlext;
$filemoyenne = "moyenne".$htmlext;
$fileresumemenu = "menu".$htmlext;

# graphs used by pages and computed by week
$statweekrepert = "week_rep";

#### a supprimer ????

$file_now = "now".$htmlext;
$filehour = "stat-hour".$htmlext;
$fileday = "stat-day".$htmlext;
$fileweek = "stat-week".$htmlext;
$filemonth = "stat-month".$htmlext;

#

$filesites = "index".$htmlext;
$filepages = "index".$htmlext;
$filepays = "index".$htmlext;
$filerepert = "list-report".$htmlext;
$filescript = "index".$htmlext;

$filereport = $filerepert;  # a supprimer
$filevirtual = "virtual".$htmlext;

$topframe = "top".$htmlext;
$bottomframe = "bottom".$htmlext;

$unresolved = "unresolved".$htmlext;

# icons

$icon_hosts = "hosts".$pngext;
$icon_countries = "countries".$pngext;
$icon_pages = "pages".$pngext;
$icon_dir = "dir".$pngext;
$icon_hours = "hours".$pngext;
$icon_days = "days".$pngext;
$icon_weeks = "weeks".$pngext;
$icon_months = "months".$pngext;
$icon_refer = "refer".$pngext;
$icon_spider = "spider".$pngext;
$icon_session = "session".$pngext;
$icon_error = "error".$pngext;
$icon_agent = "agent".$pngext;
$icon_doc = "document".$pngext;
$icon_script = "script".$pngext;
$icon_virtual = "virtual".$pngext;
$icon_filetype = "filetype".$pngext;
$icon_screensize = "screensize".$pngext;
$icon_traffic = "traffic".$pngext;
$icon_virus = "virus".$pngext;
$icon_squid = "squid".$pngext;
$icon_status = "status".$pngext;
$icon_destination = "destination".$pngext;

$icon_tree = "tree".$pngext;
$icon_new = "new".$pngext;
$icon_linksym = "linksym".$pngext;
$icon_linkerr = "linkerr".$pngext;
$icon_docrepert = "docrepert".$pngext;
$icon_useless = "useless".$pngext;
$icon_linkabs = "linkabs".$pngext;
$icon_info = "info".$pngext;
$icon_info2 = "info2".$pngext;
$icon_temp = "temp".$pngext;
$icon_verif = "verif".$pngext;
$icon_pie = "pie".$pngext;
$icon_null = "null".$pngext;
$icon_links = "links".$pngext;
$icon_ima = "ima".$pngext;
$icon_trash = "trash".$pngext;
$icon_cdrom = "cdrom".$pngext;

$icon_duree = "duree".$pngext;
$icon_notes = "notes".$pngext;
$icon_descsess = "descsess".$pngext;
$icon_sessmul = "sessmul".$pngext;
$icon_time = "time".$pngext;
$icon_unread = "unread".$pngext;
$icon_login = "login".$pngext;
$icon_users = "users".$pngext;
$icon_reading = "reading".$pngext;

$icon_new_w3perl = "new_stat".$gifext;
$icon_fleched = "fleched".$pngext;
$icon_flecheg = "flecheg".$pngext;
$icon_flecheh = "flecheh".$pngext;
$icon_go = "go".$pngext;

$icon_weight = "weight".$pngext;
$icon_moyenne = "moyenne".$pngext;

$icon_pdf = "pdf".$pngext;
$icon_csv = "csv".$pngext;
$icon_print = "print".$pngext;
$icon_mail = "mail".$pngext;

$icon_year = "year".$pngext;
$icon_xml = "xml".$pngext;
$icon_hacker = "hacker".$pngext;
$icon_spam = "spam".$pngext;
$icon_bounce = "bounce".$pngext;

$dirdomain = "domain";
$dirdownload = "download";
$earthmap = "earth.jpg";

$extconv = "fileext";
$filetype = "filetype";

$dirflags = "flags";
$pagedate = "pagedate";
$pagehas = "pagehas";

$dirtraffic = "traffic";
$filevirus = "virus".$htmlext;
$virusdef = "virus";
$filesquid = "squid".$htmlext;

$icon_help = "help".$gifext;
$dirhelp = "help";

$doctype = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">";
$charset = "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">";

$dircsv = "csv";
$dirpdf = "pdf";
$dirjs = "js";
$dircss = "css";

$sorttablejs = "sorttable.js";
$helpjs = "help.js";
$calendarjs = "basiccalendar.js";

$css_w3perl = "w3perl.css";
$css_help = "help.css";

$refspam_ip = "referrer-ip.txt";
$refspam_standard = "referrer-standard.txt";
$increferspam = "referer_spam";

$filescreensize = "screensize".$htmlext;

$miscstats_string = "/stats_w3perl_screensize/miscstats.js";
$incscreensize = "screensize";

$users = "users";
$pdfext = ".pdf";

@selection = () if ($mail_format == 1);
$searchjs = "search.js";
$toggle_on = "chkCheckAll.gif";
$toggle_off = "chkUnCheckAll.gif";

$nb_rss_item = 20;
$icon_mini_rss = "rss".$pngext;
$icon_rss = "rss".$pngext;
$filerss= "rss";
$xmlext = ".xml";
$dirxml = "xml";

1;
